(*
 * SNU 4190.310 Programming Languages (Fall 2010)
 *
 * Encoding
 *)

open Hw4_1
open Hw4_2
open Pp
open M

exception Lambda_NOTINT

let lexp2nat exp = 
	let rec getInt f x e =
		(match e with
		  Lambda.App (a,b) -> if a = Lambda.Id f then 1 + (getInt f x b) else raise Lambda_NOTINT
		| Lambda.Id x' -> if x = x' then 0 else raise Lambda_NOTINT
		| Lambda.Lam (_, _) -> raise Lambda_NOTINT)
	in
	match exp with
	  Lambda.Lam (f, Lambda.Lam (x, e)) -> getInt f x e
	| _ -> raise Lambda_NOTINT

let main () =
    let src = ref "" in
    let _ =
        Arg.parse
          []
          (fun x -> src := x)
          ("Usage: " ^ (Filename.basename Sys.argv.(0)) ^ " [-ptree] [file]")
    in
	let lexbuf = Lexing.from_channel (if !src = "" then stdin else open_in !src) in
    let pgm = Parser.program Lexer.start lexbuf in
	
	print_string "==============\n";
	print_string "input program\n";
	print_string "==============\n";
	M_Printer.print pgm;
	print_string "\n\n=============\n";
	print_string "output program\n";
	print_string "==============\n";
	Pp.pp (HW.encode pgm);
	print_string "\n\nevalm m = ";
	print_int (M_Runner.evalm pgm);
	print_string "\nlexp2nat (reduce (encode m)) = ";
	print_int (lexp2nat (HW1.reduce (HW.encode pgm)))
	


let _ = main ()
